<template>
  <!-- @TODO Improve: Можно потом добавить семантики в разметку.
  > nav > ul > li > link -->
  <div
    :class="{ office: isOffice } "
    v-if="auth">
    <flink
      v-if="isOffice"
      href="/cabinet/wrench/profile"
      domain="main"
      class="profileNavigation-link _profile"
      :class="{ active: navActive==='profile'}">
      <span class="title">Настройка</span>
    </flink>

    <template v-if="auth.isOrganization">
      <flink
        href="/cabinet/price-upload/upload"
        domain="main"
        @click.native="openOrganizationLink($event)"
        class="profileNavigation-link _price">
        <span :class="{ title: isOffice }">Мои прайсы</span>
      </flink>
      <flink
        v-if="!isOffice"
        href="/cabinet/price-upload/history"
        domain="main"
        @click.native="openOrganizationLink($event)"
        class="profileNavigation-link _history">
        <span class="text">История загрузок</span>
      </flink>
    </template>

    <flink
      :href="warehouseLink"
      domain="main"
      @click.native="openWarehouseLink($event)"
      class="profileNavigation-link _warehouse">
      <span :class="{ title: isOffice }">Мой склад</span>
    </flink>

    <div class="profileNavigation-group">
      <template v-if="auth.isOrganization">
        <flink
          v-if="auth.organizationSended"
          @click.native="$ym('requests_in')"
          href="/cabinet/inbox"
          domain="main"
          class="profileNavigation-link _inbox"
          :class="{ active: navActive==='inbox'}">
          <span class="icon">
            <img
              svg-inline
              src="~/assets/svg/icons/i-profile-response.svg">
          </span>
          <span :class="{ title: isOffice }">
            Входящие
            <span
              class="-accent"
              v-if="counters.countNewIncomingRequests > 0"> ({{ counters.countNewIncomingRequests }})
            </span>
          </span>
        </flink>
        <span
          v-else
          @click="showInfoOrganizationSended"
          class="profileNavigation-link _inbox"
          :class="{ disabled : !isOffice && !counters.countIncomingRequests }">
          <span :class="{ title: isOffice }">Входящие запросы</span>
        </span>

        <flink
          href="/cabinet/outbox"
          domain="main"
          @click.native="$ym('requests_out')"
          class="profileNavigation-link _outbox"
          :class="{ disabled : !isOffice && (counters.countOutgoingRequests === 0), active: navActive==='outbox' }">
          <span class="icon">
            <img
              svg-inline
              src="~/assets/svg/icons/i-profile-incomming-req.svg">
          </span>
          <span :class="{ title: isOffice }">
            Исходящие
            <span
              class="-accent"
              v-if="counters.countNewOutgoingRequests > 0">({{ counters.countNewOutgoingRequests }})
            </span>
          </span>
        </flink>

        <flink
          href="/cabinet/reviews/about-me"
          domain="main"
          class="profileNavigation-link _about-me"
          :class="{ disabled : !isOffice && !counters.hasAboutMeReviews && !counters.hasMyReviews }">
          <span :class="{ title: isOffice }">Отзывы</span>
          <span
            v-if="counters.countUnreadReviews > 0"
            class="-accent">
            {{ counters.countUnreadReviews }}
          </span>
        </flink>
      </template>

      <template v-else>
        <flink
          href="/cabinet/outbox"
          domain="main"
          @click.native="$ym('my_requests')"
          class="profileNavigation-link _my-requests"
          :class="{ disabled : !isOffice && !counters.countOutgoingRequests }">
          <span :class="{ title: isOffice }">Мои запросы</span>
          <span
            v-if="counters.countNewOutgoingRequests > 0"
            class="counter">
            {{ counters.countNewOutgoingRequests }}
          </span>
        </flink>
        <flink
          href="/cabinet/reviews/my"
          domain="main"
          class="profileNavigation-link _my-reviews"
          :class="{ disabled : !isOffice && !counters.hasMyReviews }">
          <span :class="{ title: isOffice }">Мои отзывы</span>
        </flink>
      </template>
      <!--TODO: Скрыли нет страницы Корзина-->
      <!--    <flink-->
      <!--      v-if="!isOffice"-->
      <!--      href="/cart"-->
      <!--      rel="nofollow"-->
      <!--      domain="main"-->
      <!--      class="profileNavigation-link _my-cart"-->
      <!--      :class="{ disabled : $store.getters['cart/counter'] === 0 }">-->
      <!--      <span class="text">-->
      <!--        Корзина-->
      <!--        <span-->
      <!--          v-if="$store.getters['cart/counter']"-->
      <!--          class="-accent"> ({{ $store.getters['cart/counter'] }})</span>-->
      <!--      </span>-->
      <!--    </flink>-->
    </div>

    <div class="profileNavigation-group">
      <flink
        href="/cabinet/check-auto"
        domain="main"
        class="profileNavigation-link _check-auto">
        <span :class="{ title: isOffice }">Проверки авто</span>
      </flink>

      <flink
        href="/cabinet/garage"
        domain="main"
        class="profileNavigation-link _garage">
        <span :class="{ title: isOffice }">Гараж</span>
      </flink>

      <flink
        v-if="!isOffice"
        href="/cabinet/garage/parts-searched"
        domain="main"
        class="profileNavigation-link _parts-searched">
        <span class="icon">
          <img
            svg-inline
            src="~/assets/svg/icons/i-profile-search-history.svg">
        </span>
        <span>Вы искали</span>
      </flink>
    </div>

    <div class="profileNavigation-group">
      <flink
        v-if="hasStat"
        href="/cabinet/statistics/clicks"
        domain="main"
        class="profileNavigation-link _clicks"
        :class="{ active: navActive==='statistics'}">
        <span :class="{ title: isOffice }">Статистика</span>
      </flink>
    </div>
  </div>
</template>

<script>
import { createNamespacedHelpers } from 'vuex';

const STORE_USER = createNamespacedHelpers('user');

export default {
  name: 'AppProfileLinks',
  props: {
    isOffice: { /* !isOffice это profileSidebar */
      type: Boolean,
      default: false,
    },
    navActive: {
      type: String,
      default: null,
    },
    auth: {
      type: Object,
      default() { return null; },
    },
  },
  computed: {
    ...STORE_USER.mapState(['counters']),
    ...STORE_USER.mapGetters(['hasStat']),
    warehouseLink() {
      if (this.auth.isOrganization) {
        return '/cabinet/warehouse/new-parts';
      }
      return '/cabinet/warehouse/do-parts';
    },
  },
  methods: {
    openOrganizationLink(event) {
      if (!this.auth.organizationSended) {
        this.showInfoOrganizationSended();
        event.preventDefault();
        return false;
      }

      if (!this.auth.isOrganizationWithShop) {
        this.showInfoWithShop();
        event.preventDefault();
        return false;
      }

      return true;
    },
    openWarehouseLink(event) {
      if (!this.auth.isCompleteProfile) {
        this.showInfoCompleteProfile();
        event.preventDefault();
        return false;
      }
      if (this.auth.isOrganization) {
        return this.openOrganizationLink(event);
      }
      return true;
    },
    // @TODO обсудить повединие кнопок
    showInfoOrganizationSended() {
      // this.showInfoModal({
      //   text: 'Необходимо заполнить <br/> данные организации',
      //   buttonText: 'Перейти к заполнению',
      //   buttonUrl: '/cabinet/wrench/organization-info#/new',
      //   buttonDomain: 'main',
      //   buttonVisibility: true,
      // });
      this.$ym('lk_modal_shown');
    },
    showInfoWithShop() {
      // this.showInfoModal({
      //   text: 'Необходимо добавить магазин',
      //   buttonText: 'Перейти к добавлению',
      //   buttonUrl: '/cabinet/wrench/organization-sto/shop/create/',
      //   buttonDomain: 'main',
      //   buttonVisibility: true,
      // });
      this.$ym('lk_modal_shown');
    },
    showInfoCompleteProfile() {
      // this.showInfoModal({
      //   text: 'Необходимо заполнить профиль',
      //   buttonText: 'Перейти к заполнению',
      //   buttonUrl: '/cabinet/wrench/profile',
      //   buttonDomain: 'main',
      //   buttonVisibility: true,
      // });
      this.$ym('lk_modal_shown');
    },
  },
};
</script>

<style lang="postcss">

</style>
